/* Simple Plugin API
 * Copyright (C) 2018 Wim Taymans <wim.taymans@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef __SPA_DEBUG_NODE_H__
#define __SPA_DEBUG_NODE_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <spa/node/node.h>
#include <spa/debug/dict.h>

#ifndef spa_debug
#define spa_debug(...)	({ fprintf(stderr, __VA_ARGS__);fputc('\n', stderr); })
#endif

int spa_debug_port_info(int indent, const struct spa_port_info *info)
{
        spa_debug("%*s" "struct spa_port_info %p:", indent, "", info);
        spa_debug("%*s" " flags: \t%08x", indent, "", info->flags);
        spa_debug("%*s" " rate: \t%u", indent, "", info->rate);
        spa_debug("%*s" " props:", indent, "");
        if (info->props)
                spa_debug_dict(indent + 2, info->props);
        else
                spa_debug("%*s" "  none", indent, "");
        return 0;
}


#ifdef __cplusplus
}  /* extern "C" */
#endif

#endif /* __SPA_DEBUG_NODE_H__ */
